<template>
    <a :href="shareLink" :target=" target">
        <slot/>
    </a>
</template>

<script setup lang="ts">
import { computed, ComputedRef } from 'vue';
import { AvailableNetworks } from '../networks';
    const props = defineProps<{
    network: String,
    url: String,
    title: String,
    blank?: boolean,
    description?: String,
    quote?: String,
    hashtags?: [String],
    twitterUser?: String,
    media?: String,
    popup?: {
        type: object,
        default: () => ({
        width: 626,
        height: 436
        })
    }
}>();

    let target: string;
    if (props.blank === true) target = 'blank';
    const networks: ComputedRef<any> = computed(() => {
            return AvailableNetworks;
        });

    let netUrl = networks.value[props.network as any] as string;


    const encodedHashtags = computed(() => {
        if (props.network === 'facebook' && props.hashtags) {
            return props.hashtags.join('%23')
        } else if (props.network === 'twitter') {
            return props.hashtags?.join()
        }
    })


    const shareLink = computed(() => {
        if (!props.hashtags) netUrl = netUrl.replace('&hashtags=@h', '');
        if (!props?.twitterUser || props.twitterUser === undefined) netUrl = netUrl.replace('@tu', '');
        return netUrl
            .replace(/@tu/g, '&via=' + encodeURIComponent(props.twitterUser as string))
            .replace(/@u/g, encodeURIComponent(props.url as string))
            .replace(/@t/g, encodeURIComponent(props.title as string))
            .replace(/@d/g, encodeURIComponent(props.description as string))
            .replace(/@q/g, encodeURIComponent(props.quote as string))
            .replace(/@h/g, encodedHashtags.value as string)
            .replace(/@m/g, encodeURIComponent(props.media as string));
    })

</script>